/*
 * New editor name:  tde, the Thomson-Davis Editor.
 * Author:           Frank Davis
 * Date:             June 5, 1991
 *
 * This modification of Douglas Thomson's code is released into the
 * public domain, Frank Davis.  You may distribute it freely.
 *
 * This file defines all functions in editor.
 */

#define   Help                    1 
#define   Rturn                   2 
#define   NextLine                3
#define   BegNextLine             4 
#define   LineDown                5 
#define   LineUp                  6 
#define   CharRight               7 
#define   CharLeft                8 
#define   WordRight               9 
#define   WordLeft                10
#define   ScreenDown              11
#define   ScreenUp                12
#define   EndOfFile               13
#define   TopOfFile               14
#define   BotOfScreen             15
#define   TopOfScreen             16
#define   EndOfLine               17
#define   BegOfLine               18
#define   JumpToLine              19
#define   CenterWindow            20
#define   CenterLine              21
#define   HorizontalScreenRight   22
#define   HorizontalScreenLeft    23
#define   ScrollDnLine            24
#define   ScrollUpLine            25
#define   FixedScrollUp           26
#define   FixedScrollDn           27
#define   ToggleOverWrite         28
#define   ToggleIndent            29
#define   ToggleSdel              30
#define   SetTabs                 31
#define   Tab                     32
#define   ParenBalance            33
#define   BackSpace               34
#define   DeleteChar              35
#define   DeleteLine              36
#define   DelEndOfLine            37
#define   WordDelete              38
#define   AddLine                 39
#define   SplitLine               40
#define   JoinLine                41
#define   DuplicateLine           42
#define   AbortCommand            43
#define   UndoLine                44
#define   UndoDelete              45
#define   ToggleSearchCase        46
#define   FindForward             47
#define   FindBackward            48
#define   RepeatFindForward       49
#define   RepeatFindBackward      50
#define   ReplaceForward          51
#define   ReplaceBackward         52
#define   MarkBlock               53
#define   MarkLine                54
#define   UnMarkBlock             55
#define   FillBlock               56
#define   CopyBlock               57
#define   KopyBlock               58
#define   MoveBlock               59
#define   OverlayBlock            60
#define   DeleteBlock             61
#define   BlockToFile             62
#define   PrintBlock              63
#define   BlockExpandTabs         64
#define   File                    65
#define   EditFile                66
#define   Save                    67
#define   SaveAs                  68
#define   RedrawScreen            69
#define   SizeWindow              70
#define   SplitScreen             71
#define   NextWindow              72
#define   PreviousWindow          73
#define   ZoomWindow              74
#define   NextHiddenWindow        75
#define   Quit                    76
#define   TwoCharKey              0x80

/*
 *  These are not functions.  They redefine the Control code sequence.
 */

#define     CNTRL_A             431
#define     CNTRL_B             432
#define     CNTRL_C             433
#define     CNTRL_D             434
#define     CNTRL_E             435
#define     CNTRL_F             436
#define     CNTRL_G             437
#define     CNTRL_H             438
#define     CNTRL_I             439
#define     CNTRL_J             440
#define     CNTRL_K             441
#define     CNTRL_L             442
#define     CNTRL_M             443
#define     CNTRL_N             444
#define     CNTRL_O             445
#define     CNTRL_P             446
#define     CNTRL_Q             447
#define     CNTRL_R             448
#define     CNTRL_S             449
#define     CNTRL_T             450
#define     CNTRL_U             451
#define     CNTRL_V             452
#define     CNTRL_W             453
#define     CNTRL_X             454
#define     CNTRL_Y             455
#define     CNTRL_Z             456
